searchNodes=[{"ref":"Exconfig.html","title":"Exconfig","type":"module","doc":"The module Exconfig provides the API for the Exconfig-package. This is get/0 ... get all cached settings get/3 ... get a specific entry (read if not cached) and clear_cache!/0 ... remove all entries from the cache"},{"ref":"Exconfig.html#clear_cache!/0","title":"Exconfig.clear_cache!/0","type":"function","doc":"Remove all entries from the cache, so they will be re-read if accessed again."},{"ref":"Exconfig.html#get/0","title":"Exconfig.get/0","type":"function","doc":"Get the entire loaded cache. Examples iex&gt; Exconfig.get() %{}"},{"ref":"Exconfig.html#get/3","title":"Exconfig.get/3","type":"function","doc":"Get a value from cache or load it if not cached yet. Examples Return the default if key is not found anywhere iex&gt; Exconfig.get(:exconfig, :unknown_config_key, :not_found) :not_found Return from a value configured in config/* iex&gt; Exconfig.get(:logger, :level, :error) :debug Return a value provided as a system environment var The given key will be converted to a string, if it is an :atom. Also, it will be uppercased. iex&gt; System.put_env(&quot;ELIXIRRULEZ&quot;, &quot;true&quot;) iex&gt; Exconfig.get(:exconfig, :elixirrulez, :not_found) &quot;true&quot;"},{"ref":"Exconfig.Cache.html","title":"Exconfig.Cache","type":"module","doc":"PRIVATE MODULE -- Do not use this module directely but through Exconfig API only. The module implements a GenServer handling the state of the cache."},{"ref":"Exconfig.Cache.html#child_spec/1","title":"Exconfig.Cache.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Exconfig.Cache.html#clear!/0","title":"Exconfig.Cache.clear!/0","type":"function","doc":"Clear the current cache. Example iex&gt; Exconfig.Cache.clear!() iex&gt; Exconfig.get() %{}"},{"ref":"Exconfig.Cache.html#get/0","title":"Exconfig.Cache.get/0","type":"function","doc":"Get the entire current cache as a Map. Example iex&gt; Exconfig.clear_cache!() iex&gt; Exconfig.Cache.get() %{} iex&gt; Exconfig.clear_cache!() iex&gt; Exconfig.get(:logger, :level ) iex&gt; Exconfig.Cache.get() %{{:logger, :level} =&gt; :debug}"},{"ref":"Exconfig.Cache.html#lookup/3","title":"Exconfig.Cache.lookup/3","type":"function","doc":"Find a given key or return {:error, :key_not_found}"},{"ref":"Exconfig.Cache.html#start_link/1","title":"Exconfig.Cache.start_link/1","type":"function","doc":"Start link function used from Exconfig.Application to start a single instance of this Cache-Server as a supervised worker."},{"ref":"Exconfig.Cache.html#update/3","title":"Exconfig.Cache.update/3","type":"function","doc":"Update the given key in the cache with a new value. Also inserts a new key/value if it not exists yet. Example iex&gt; Exconfig.Cache.clear!() iex&gt; Exconfig.get(:logger,:level) iex&gt; Exconfig.Cache.update(:logger,:level,:new_level) iex&gt; Exconfig.get() %{{:logger, :level} =&gt; :new_level}"},{"ref":"readme.html","title":"Exconfig","type":"extras","doc":"Exconfig At Github Hex"},{"ref":"readme.html#context","title":"Exconfig - Context","type":"extras","doc":"Don&#39;t use ENV-settings for compile-time configuration. (Because it is hard to maintain your environment-settings for different deployments. Imagine you want to build a Docker-image for your Phoenix-application and you use something like plug SomePlug, config_value: System.get_env(&quot;SOME_KEY&quot;) plug is a macro and therefore, SOME_KEY gets evaluated at compile time. If SOME_KEY is customer-related, this setting get&#39;s burned into the image and may surprisingly pop up at the wrong customer&#39;s server. The Exconfig-package will help you not to make this mistake. Just use Exconfig.get instead of all your Application.get_env and System.get_env calls. Because the cache-server of Exconfig will not run at compile-time you&#39;ll get a compile-error if you try to use System-envs from your busines-logic."},{"ref":"readme.html#usage","title":"Exconfig - Usage","type":"extras","doc":"The application starts a GenServer and caches configuration at run time. Loading configuration happens in two steps where each step overwrites eventually existing values from previous steps. Application.get_env(:app, :key) default System.get_env(:key) default Once the value is cached it will be returned from the GenServer state rather than re-reading it from the environment again. Using Exconfig.clear_cache!/0 will drop the cache and values will be loaded again if being accessed later. Example: iex&gt; value = Exconfig.get(:my_app, :foo, &quot;bar&quot; ) &quot;bar&quot; Exconfig.get/3 will first lookup for :myapp/:foo in the Exconfig.Cache (a GenServer) and if not found load from Application, System, or returns the default."},{"ref":"readme.html#installation","title":"Exconfig - Installation","type":"extras","doc":"Available in Hex. The package can be installed by adding Exconfig to your list of dependencies in mix.exs: def deps do [ {:exconfig, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with mix docs (ExDoc) and is published at https://hexdocs.pm/exconfig."},{"ref":"license.html","title":"MIT License","type":"extras","doc":"MIT License Copyright (c) 2019 Andreas Altendorfer, andreas@altendorfer.at Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]